/* AMX Mod X
*   User Flags Control
*
* (c) Copyright 2007 by VEN
*
* This file is provided as is (no warranties)
*/

#include <amxmodx>
#include <amxmisc>

public plugin_init() {
	register_plugin("User Flags Control", "0.1", "VEN")
	register_concmd("user_flags", "cmd_user_flags", ADMIN_RCON, "<name or #userid> [flags] [+|-] - gets/sets/adds/subtracts user flags")
}

public cmd_user_flags(caller, level, cid) {
	if (!cmd_access(caller, level, cid, 2))
		return PLUGIN_HANDLED

	static arg[32], id
	read_argv(1, arg, sizeof arg - 1)
	id = cmd_target(caller, arg, 0)
	if (!id)
		return PLUGIN_HANDLED

	if (read_argc() == 2) {
		get_flags(get_user_flags(id), arg, sizeof arg - 1)
		console_print(caller, "User's flags:   %s", arg)
		return PLUGIN_HANDLED
	}

	static flags
	read_argv(2, arg, sizeof arg - 1)
	flags = read_flags(arg)
	read_argv(3, arg, 1)
	switch (arg[0]) {
		case '+': set_user_flags(id, flags)
		case '-': remove_user_flags(id, flags)
		default : {
			remove_user_flags(id, -1)
			set_user_flags(id, flags)
		}
	}

	return PLUGIN_HANDLED
}

